apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "wandertag-app.fullname" . }}
  namespace: {{ .Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ include "wandertag-app.fullname" . }}
    {{- include "wandertag-app.labels" . | nindent 4 }}
spec:
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ include "wandertag-app.fullname" . }}
      {{- include "wandertag-app.selectorLabels" . | nindent 6 }}
  replicas: {{ .Values.replicaCount }}
  strategy:
    {{- with .Values.strategy }}
        {{- toYaml . | nindent 4 }}
    {{- end }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ include "wandertag-app.fullname" . }}
        {{- include "wandertag-app.selectorLabels" . | nindent 8 }}
    spec:
      serviceAccountName: {{ include "wandertag-app.serviceAccountName" . }}
      containers:
        - name: {{ include "wandertag-app.fullname" . }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.config.port }}
              protocol: TCP
          env:
            # Database
            - name: DATABASE_HOST
              value: {{ printf "%s-postgresql" (include "wandertag-app.fullname" .) }}
            - name: DATABASE_PORT
              value: {{ .Values.postgresql.service.port | quote }}
            - name: DATABASE_NAME
              value: postgres
            - name: DATABASE_USER
              value: postgres
            - name: DATABASE_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.postgresql.existingSecret.name }}
                  key: {{ .Values.postgresql.existingSecret.passwordKey }}
            # Config
            - name: WEBSERVER_HOST
              value: {{ .Values.config.host | quote }}
            - name: WEBSERVER_PORT
              value: {{ .Values.config.port | quote }}
            - name: UPLOAD_ACTIVE
              value: {{ .Values.config.uploadActive | quote }}
            # Secret
            - name: GET_DATA_SECRET
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.dataSecret.existingSecret.name }}
                  key: {{ .Values.dataSecret.existingSecret.key }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          {{- if .Values.startupProbe.enabled }}
          startupProbe:
            {{- omit .Values.startupProbe "enabled" | toYaml | nindent 12 }}
            tcpSocket:
              port: http
          {{- end }}
          {{- if .Values.readinessProbe.enabled }}
          readinessProbe:
            {{- omit .Values.readinessProbe "enabled" | toYaml | nindent 12 }}
            httpGet:
              port: http
          {{- end }}
          {{- if .Values.livenessProbe.enabled }}
          livenessProbe:
            {{- omit .Values.livenessProbe "enabled" | toYaml | nindent 12 }}
            httpGet:
              port: http
          {{- end }}
